
import 'dart:convert';
import 'dart:developer';

import 'package:crud_service/File/WIIFileRequestEntity.dart';
import 'package:crud_service/File/WIIFileResponse.dart';
import 'package:crud_service/crud_service.dart';
import 'package:dio/dio.dart';
import 'package:flutter/cupertino.dart';

class WIIFileUploadService {

  static Dio dio = new Dio(BaseOptions(baseUrl: ServiceConfig.shared.baseUrl()));
  static JsonCodec json = const JsonCodec();

  Future<WIIFileResponse> uploadFiles(List<WIIFileRequestEntity> entitys) async {

    String path = ServiceConfig.shared.fileUploadPath;
    String key = ServiceConfig.shared.fileUploadKey;

    FormData formData = FormData();
    for (WIIFileRequestEntity entity in entitys) {
      MultipartFile file = await entity.createFormData();

      MapEntry entry = new MapEntry<String, MultipartFile>(key, file);
      formData.files.add(entry);
    }
    var r = await dio.post(path, data: formData);

    var responseData = r.data;
    if (responseData is String) {
      print(responseData);
      Map<String, dynamic> jsonData = json.decode(responseData);
      return WIIFileResponse(jsonData);
    } else {
      print(responseData.toString());
      return WIIFileResponse(responseData);
    }
  }
}