
import 'package:crud_service/Model/RequestField.dart';
import 'package:crud_service/crud_service.dart';
import 'package:flutter/cupertino.dart';

import 'device_entity.dart';

class DeviceListService {
  ListService service = ListService<DeviceEntity>();

  Future<List<DeviceEntity>> loadFirst() async {
    String path = "/api/v1/fec-df/monitor-device-es/";
    var filters = await requestFilters();
    var page = RequestPage(1, 20);
    var sort = RequestSort("dev_pointCt", true);
    var search = RequestSearch("手报", ["dev_pointName"]);
    var fileds = listFileds();
    var response = await service.list(path, page, filters: filters, sorts: [sort], search: search, fields: fileds);
    return response;
  }

  Future<List<RequestFilter>> requestFilters() async {
    var st = RequestFilter<int>(CRUDOperator.NE, "st", 9);

    var spaceId = "5dad4d9dde59ac66be8f41e6";

    var propSpaceId = RequestFilter<String>(CRUDOperator.EQUALS, "prop_propSpaceId", spaceId);
    var mw_status = RequestFilter<int>(CRUDOperator.EQUALS, "mw_status", 1);
    var mw_monitorStatus = RequestFilter<List<int>>(CRUDOperator.IN, "mw_monitorStatus", [1, 780, 880, 980]);
    return [st, propSpaceId, mw_status, mw_monitorStatus];
  }

  List<RequestField> listFileds() {
    var id = RequestField("id");
    var name = RequestField("dev_pointName");
    return [id, name];
  }
}